var firenes = {
	prefsfirenes: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.firenes."),

	init: function(){
		var ver = -1, firstrun = true;
		var gExtensionManager = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
		var current = gExtensionManager.getItemForID("firenes@facundo.zaldo").version;
		var strbundle = document.getElementById("firenes-strings");

		try{
			ver = firenes.prefsfirenes.getCharPref("version");
			firstrun = firenes.prefsfirenes.getBoolPref("firstrun");
		}catch(e){
			//nada
		}finally{
			if (firstrun){
				firenes.prefsfirenes.setBoolPref("firstrun",false);
				firenes.prefsfirenes.setCharPref("version",current);

				// Se ejecuta solo cuando se instala la extension
				var web = strbundle.getString("extensions.firenes.pagina.install");
				window.setTimeout(function(){ gBrowser.selectedTab = gBrowser.addTab(web);}, 1500);
			}

			if (ver!=current && !firstrun){ // !firstrun asegura que no se entre en la primera instalacion.
				firenes.prefsfirenes.setCharPref("version",current);

				// Se ejecuta solo cuando se actualiza la extension
				var web = strbundle.getString("extensions.firenes.pagina.update");
				window.setTimeout(function(){ gBrowser.selectedTab = gBrowser.addTab(web);}, 1500);
			}
		}
		window.removeEventListener("load",function(){ firenes.init(); },true);
	},

	onLoad: function(){
		this.initialized = true;
		this.strings = document.getElementById("firenes-strings");
	},

	onMenuItemCommand: function(e) {
		var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
 
		toggleSidebar('viewEmptySidebar');
	},

	onToolbarButtonCommand: function(e) {
		firenes.onMenuItemCommand(e);
	},

	getLista: function(){
		var barra = document.getElementById('barraCargando');
		barra.setAttribute("collapsed", "false");

		firenes.setLista('Nes', 'http://firenes.zaldo.com.ar/listanes.xml');
		firenes.setLista('Gb', 'http://firenes.zaldo.com.ar/listagb.xml');
		firenes.setFavoritos('Nes');
		firenes.setFavoritos('Gb');
	},

	setLista: function(tipo, direccion){
		var listajuegos = document.getElementById('ListaJuegos'+tipo);
		var listapapelera = document.getElementById('ListaJuegosPapelera'+tipo);
		var listatop = document.getElementById('ListaJuegosTop'+tipo);

		var req = new XMLHttpRequest();
		req.open('GET', direccion, true);
		req.overrideMimeType('text/xml');
		req.onreadystatechange = function (aEvt) { 
			if (req.readyState == 4) {
				if(req.status == 200) {
					try{
						var juegos = req.responseXML.getElementsByTagName('root').item(0).getElementsByTagName('j');
						var i = juegos.length-1;
						do{ //for (var i = juegos.length-1; i > -1; i--) { 
							var juego = juegos.item(i);
							var nombre = juego.getElementsByTagName('n').item(0).firstChild.data;
							var archivo = 'rom='+juego.getElementsByTagName('r').item(0).firstChild.data;
							
							if(juego.getElementsByTagName('e').item(0).firstChild.data >= 2){
								listapapelera.appendItem(nombre, archivo);
							} else {
								listajuegos.appendItem(nombre, archivo);
								if(juego.getElementsByTagName('t').item(0).firstChild.data >= 's')
									listatop.appendItem(nombre, archivo);
							}
						} while (--i > -1);
					listajuegos.selectedIndex = 0;
					
				}catch(e){
					dump("FireNes: Error al parsear el xml");
				}
				firenes.quitarBarra();

				} else {
					dump("FireNes: No se pudo cargar la "+listajuegos);
					firenes.quitarBarra();
				}
			}
		};
		req.send(null);
	},

	quitarBarra: function(){
		var barra = document.getElementById('barraCargando');
		barra.setAttribute("collapsed", "true");
	},

	runJuego: function(lista,tipo){
		var listajuegos = document.getElementById('ListaJuegos'+lista+tipo);
		var itemjuego = listajuegos.currentItem;
		var codebase;
		var size;

		var atr = firenes.getAtributos(tipo);
		
		if(tipo == 'Nes'){
			var size = firenes.prefsfirenes.getIntPref('nes.size');
			var alto = 256*size;
			var ancho = 240*size;
			tam = '&height='+ ancho + '&width='+alto;
			alto = alto - 26;
			ancho = ancho - 26; // Corrige el pequeño desfasaje del vNES
		}
		if(tipo == 'Gb'){
			var size = firenes.prefsfirenes.getIntPref('gb.size');
			var alto = 160*size;
			var ancho = 144*size;
			tam = '&height='+ ancho + '&width='+alto;
		}
		
		try{ 
			var romjuego = 'http://firenes.zaldo.com.ar/emulador'+tipo+'.php?'+itemjuego.value+atr+tam; 
			firenes.prefsfirenes.setCharPref('rom', romjuego);
		
			var ventana = window.open('chrome://firenes/content/juego.xul', 'FireNes', 'width='+alto+',height='+ancho+',scrollbars=no,chrome,titlebar,toolbar,centerscreen,resizable=no');
			ventana.focus(); 
		}catch(e){
			alert(e);
		}
	},

	cargaJuego: function(){
		try{
			var romjuego = firenes.prefsfirenes.getCharPref('rom')+'';

			var pagina = document.getElementById("pagina-juego");
			pagina.setAttribute("src", romjuego);
		}catch(e){
			alert(e);
		}
	},

	getAtributos: function(tipo){
		var linea = '';
		var aux;  
		var temp;

		if(tipo == 'Nes'){
			linea = firenes.setAtributoNes('nes.', 'showsoundbuffer', linea);
			linea = firenes.setAtributoNes('nes.', 'sound', linea);
			linea = firenes.setAtributoNes('nes.', 'timeemulator', linea);
			linea = firenes.setAtributoNes('nes.', 'fps', linea);
			linea = firenes.setAtributoNes('nes.', 'stereo', linea);
			linea = firenes.setAtributoNes('nes.', 'scale', linea);
			linea = firenes.setAtributoNes('nes.', 'scanlines', linea);
			linea = firenes.setAtributoNes('nes.', 'nicesound', linea);
			if(firenes.prefsfirenes.getBoolPref('nes.control.default') === false){
				linea = firenes.setAtributoControles('nes',linea);
			}
		}
		
		if(tipo == 'Gb'){
			linea = firenes.setAtributoNes('gb.', 'sound', linea);
			if(firenes.prefsfirenes.getBoolPref('gb.control.default') === false){
				linea = firenes.setAtributoControles('gb',linea);
			}
		}
		//alert(linea);
		return linea;
	},

	setAtributoNes: function(pre,opcion,linea){
		var temp = firenes.prefsfirenes.getBoolPref(pre+opcion);
		var aux;
		if (temp==true) aux="on";
		else aux="off";
		linea = linea+'&'+opcion+'='+aux;
		return linea;
	},

	setAtributoControles: function(tipo,linea){
		linea = linea+'&1up='+firenes.prefsfirenes.getCharPref(tipo+'.control.1up');
		linea = linea+'&2up='+firenes.prefsfirenes.getCharPref(tipo+'.control.2up');
		linea = linea+'&1down='+firenes.prefsfirenes.getCharPref(tipo+'.control.1down');
		linea = linea+'&2down='+firenes.prefsfirenes.getCharPref(tipo+'.control.2down');
		linea = linea+'&1right='+firenes.prefsfirenes.getCharPref(tipo+'.control.1right');
		linea = linea+'&2right='+firenes.prefsfirenes.getCharPref(tipo+'.control.2right');
		linea = linea+'&1left='+firenes.prefsfirenes.getCharPref(tipo+'.control.1left');
		linea = linea+'&2left='+firenes.prefsfirenes.getCharPref(tipo+'.control.2left');
		linea = linea+'&1start='+firenes.prefsfirenes.getCharPref(tipo+'.control.1start');
		linea = linea+'&2start='+firenes.prefsfirenes.getCharPref(tipo+'.control.2start');
		linea = linea+'&1select='+firenes.prefsfirenes.getCharPref(tipo+'.control.1select');
		linea = linea+'&2select='+firenes.prefsfirenes.getCharPref(tipo+'.control.2select');
		linea = linea+'&1a='+firenes.prefsfirenes.getCharPref(tipo+'.control.1a');
		linea = linea+'&2a='+firenes.prefsfirenes.getCharPref(tipo+'.control.2a');
		linea = linea+'&1b='+firenes.prefsfirenes.getCharPref(tipo+'.control.1b');
		linea = linea+'&2b='+firenes.prefsfirenes.getCharPref(tipo+'.control.2b');

		return linea;
	},

	notificarfail: function(tipo){
		try{
			var listajuegos = document.getElementById('ListaJuegos'+tipo);
			var itemjuego = listajuegos.currentItem;

			var expReg = /[0-9]+/;  
			var idrom = expReg.exec(itemjuego.value);

			firenes.entrar('http://www.firenes.com.ar/notificacion?id='+idrom);
		}catch(e){
			alert(e);
		}
	},

	notificartop: function(tipo){
		try{
			var listajuegos = document.getElementById('ListaJuegos'+tipo);
			var itemjuego = listajuegos.currentItem;

			var expReg = /[0-9]+/;  
			var idrom = expReg.exec(itemjuego.value);    
			
			firenes.entrar('http://www.firenes.com.ar/recomendar-como-top?id='+idrom);
		}catch(e){
			alert(e);
		}
	},

	addFavoritos: function(elemento,tipo){
		try{
			var listajuegos = document.getElementById(elemento);
			var itemjuego = listajuegos.currentItem;

			try{
				var fav = firenes.prefsfirenes.getCharPref(tipo.toLowerCase()+'.favoritos')+'||';
			}catch(e){
				fav='';
			}

			var juego = fav+itemjuego.label+'|'+itemjuego.value;
			
			firenes.prefsfirenes.setCharPref(tipo.toLowerCase()+'.favoritos', juego);
			firenes.setFavoritos(tipo);
		}catch(e){
			alert('Error al agregar a favoritos: '+e);
		}
	},

	mover: function(tipo, dir){
		try{
			var listajuegos = document.getElementById('ListaJuegosFavoritos'+tipo);
			var itemjuego = listajuegos.currentItem; 
			try{
				var fav = firenes.prefsfirenes.getCharPref(tipo.toLowerCase()+'.favoritos');
			}catch(e){
				fav='';
			}

			var fav2='';
			var pos = listajuegos.selectedIndex;
			var aux = itemjuego.label+'|'+itemjuego.value;
			var bar = fav.split("||");

			switch(dir){
				case 1:
					if(pos!=0){
						bar[pos] = bar[pos-1];
						bar[pos-1] = aux;
					}
					break;
				case 2:
					if(pos!=listajuegos.getRowCount()-1){
						bar[pos] = bar[pos+1];
						bar[pos+1] = aux;
						}
						break;
				case 3:
					bar.splice(listajuegos.currentIndex, 1);
					break;
			}
			fav2 = bar.join('||');

			if(fav2=='') firenes.prefsfirenes.clearUserPref(tipo.toLowerCase()+'.favoritos'); //Restablece sino queda ninguno
			else firenes.prefsfirenes.setCharPref(tipo.toLowerCase()+'.favoritos', fav2);

			firenes.setFavoritos(tipo);
		}catch(e){
			dump('Error al quitar de favoritos: '+e);
		}
	},

	setFavoritos: function(tipo){
		try{
			var listajuegosfavoritos = document.getElementById('ListaJuegosFavoritos'+tipo);

			while(listajuegosfavoritos.getRowCount()!=0){
				listajuegosfavoritos.removeItemAt(0);
			}
			
			try{ // Arregla si se tiene una version vieja de los favoriots
				if(firenes.prefsfirenes.getCharPref('favoritos')!=='') {
					firenes.prefsfirenes.setCharPref('nes.favoritos', firenes.prefsfirenes.getCharPref('favoritos'));
					firenes.prefsfirenes.setCharPref('favoritos', '');
				}
			}catch(e){ dump(e); }
			
			var fav = firenes.prefsfirenes.getCharPref(tipo.toLowerCase()+'.favoritos');

			var bar = fav.split("||");
			for(var i = 0;i<bar.length;i++){
				var bar2 = bar[i].split("|");
				listajuegosfavoritos.appendItem(bar2[0],bar2[1]);
			}
			
			listajuegosfavoritos.selectedIndex = -1;

		}catch(e){
			dump(e);
		}
	},

	busqueda: function(tipo){
		try{
			var tab = document.getElementById('TabLista'+tipo);
			var cajaBusqueda = document.getElementById('busqueda'+tipo);
			var elemento;

			switch(tab.selectedIndex) {
				case 0:
					elemento = 'ListaJuegos'+tipo;
					break;
				case 1:
					elemento = 'ListaJuegosTop'+tipo;
					break;
				case 2:
					elemento = 'ListaJuegosFavoritos'+tipo;
					break;
				case 3:
					elemento = 'ListaJuegosPapelera'+tipo;
					break;
				default:
					elemento = 'ListaJuegos'+tipo;
					break;
			}

			var listaJuegos = document.getElementById(elemento);

			if (cajaBusqueda.value == ''){
				listaJuegos.selectedIndex = -1;
				//listaJuegos.clearSelection();
				return;
			} else {
				var pattern = new RegExp("^" + cajaBusqueda.value, "i");
				for(var x=0; x < listaJuegos.getRowCount(); x++){
					if (pattern.test(listaJuegos.getItemAtIndex(x).label) == true){
						listaJuegos.selectedIndex = x;
						listaJuegos.scrollToIndex(x); 
						listaJuegos.ensureIndexIsVisible(x);
						break;
					}
					
				}
			}
		}catch(e){
			dump(e);
		}
	},

	abrirPagina: function (direccion){
		try{
			gBrowser.selectedTab = gBrowser.addTab(direccion);
		}catch(e){
		alert(e);
		}
	},

	entrar: function(direccion) {
		var mainWindow = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor).getInterface(Components.interfaces.nsIWebNavigation).QueryInterface(Components.interfaces.nsIDocShellTreeItem).rootTreeItem.QueryInterface(Components.interfaces.nsIInterfaceRequestor).getInterface(Components.interfaces.nsIDOMWindow);
		mainWindow.getBrowser().selectedTab = mainWindow.getBrowser().addTab(direccion);
	}
};
window.addEventListener("load",function(){ firenes.init(); },true);














